#https://forums.raspberrypi.com//viewtopic.php?f=66&t=251645
#https://dev.webonomic.nl/kodi-on-bullseye-playing-4k-on-the-rpi4
#Servicio 3.1.64 nativo funcionando: https://github.com/danielchc/docker-acestream-arm
- name: Install Kodi
  block:

  - name: Installing kodi package
    apt:
      name: kodi, kodi-pvr-hts, kodi-inputstream-adaptive
      state: present
      cache_valid_time: 3600         

  # sudo systemctl stop kodi
  - name: stop kodi service
    systemd:
      name: kodi
      state: stopped
    ignore_errors: true      

  - name: Configure Kodi daemon to autostart Kodi
    copy:
      content: |
        [Unit]
        Description = Kodi Media Center
        After = remote-fs.target network-online.target
        Wants = network-online.target

        [Service]
        User = {{ user.name }}
        Group = {{ user.group }}
        Type = simple
        ExecStart = /usr/bin/kodi-standalone
        Restart = on-abort
        RestartSec = 5

        [Install]
        WantedBy = multi-user.target
      dest: /etc/systemd/system/kodi.service
      force: yes

  - name: Install python 3.8 witch is the version supported by Kodi 19
    apt:
      name: python3.8*, patchelf
      state: present
      cache_valid_time: 3600        

  # https://www.linuxadictos.com/si-tu-addon-preferido-ha-dejado-de-funcionar-en-kodi-probablemente-sea-porque-tienes-una-version-de-python-demasiado-nueva.html  
  - name: Set Python3.8 as default python interpreter for Kodi.
    shell: patchelf --replace-needed libpython3.9.so.1.0 libpython3.8.so.1.0 /usr/lib/arm-linux-gnueabihf/kodi/kodi.bin
    become: yes

  # https://www.raspberrypi.com/documentation/computers/config_txt.html
  - name: Configure raspberry boot config.txt
    copy:
      content: |
        #By default, when connected to a 4K monitor, the Raspberry Pi 4B, 400 and CM4 will select a 30Hz refresh rate. Use this option to allow selection of 60Hz refresh rates.
        hdmi_enable_4kp60=1
        
        #TO ENABLE HEVC HW DECODING
        dtoverlay=rpivid-v4l2
        
        #FOR 4K HEVC PLAYBACK TWEAK THIS LINE:
        # Enable DRM VC4 V3D driver
        dtoverlay=vc4-kms-v3d,cma-512
        
        #Kodi on Raspbian requires a minimum of 160 MB of RAM dedicated to the GPU to function properly!. The recommended for the RPI 4 is 320 MB.
        gpu_mem=160

        #Full screen.
        disable_overscan=1
        disable_fw_kms_setup=1
        
        #Needed to install vscode server correctly with 32 bit version. Do not set to 0
        #https://medium.com/for-linux-users/how-to-make-your-raspberry-pi-4-faster-with-a-64-bit-kernel-77028c47d653
        #arm_64bit=0
      dest: /boot/config.txt
      force: yes

  # https://community.home-assistant.io/t/guide-install-hassio-and-kodi-on-same-raspberry-pi/188057#u3-change-the-memory-size-used-for-buffering-streams-in-ramu-25
  # https://kodi.wiki/view/HOW-TO:Modify_the_video_cache
  - name: Change the memory size used for buffering streams in RAM
    copy:
      content: |
        <advancedsettings version="1.0">
            <buffermode>1</buffermode>
            <memorysize>536870912</memorysize>
            <readfactor>20</readfactor>
        </advancedsettings>
      dest: /home/{{ user.name }}/.kodi/userdata/advancedsettings.xml
      force: yes
      
  # https://forums.raspberrypi.com/viewtopic.php?t=346202
  #- name: Install kms++--utils to watch if the HDMI port is used.
  #  apt:
  #    name: kms++-utils
  #    state: present
  #    cache_valid_time: 3600      

  - name: Restart Kodi service
    systemd:
      name: kodi
      state: started
      enabled: true
      daemon_reload: yes      


  - name: Copy systemd service file to server
    copy:
      src: /home/elmol/provision/scripts/eventtv.service/eventtv.service
      dest: /etc/systemd/system
      owner: root
      group: root

  - name: Start demo
    systemd:
      name: eventtv
      state: started
      enabled: yes